import torch
import torchvision
import torchvision.transforms as transforms


def load_dataset(batch_size=64):

    # Define transformation to scale the data between -1 and 1
    transform = transforms.Compose([
        transforms.ToTensor(),
        transforms.Lambda(lambda x: (x * 2) - 1)
    ])

    # Load MNIST train dataset
    train_dataset = torchvision.datasets.MNIST(root='./data', train=True, transform=transform, download=True)

    # Create a data loader for the MNIST train dataset
    train_loader = torch.utils.data.DataLoader(train_dataset, batch_size=batch_size, shuffle=True)

    # Load MNIST test dataset
    test_dataset = torchvision.datasets.MNIST(root='./data', train=False, transform=transform, download=True)

    # Create a data loader for the MNIST test dataset
    test_loader = torch.utils.data.DataLoader(test_dataset, batch_size=batch_size, shuffle=False)

    return train_loader, test_loader