import torch
from torch import nn
from dataset import load_dataset
from unet import UNet


def get_loss(noise, noise_pred):
    # TODO: Compute l2-norm between noise and noise_pred


class DiffusionModel(nn.Module):
    
    def __init__(self, reverse_process_model, beta_start, beta_end, timesteps=1000, device="cuda"):
        super().__init__()
        self.reverse_process_model = reverse_process_model

        self.betas = get_linear_beta_schedule(beta_start, beta_end, timesteps)
        # TODO: Define alphas variable for forward process based on q(xt|x0) formula
        # TODO: Define alpha_bars variable for forward process based on q(xt|x0) formula


    def get_linear_beta_schedule(beta_start, beta_end, timesteps):
        # TODO:  Compute beta values by dividing the range from beta_start to beta_end
        #        linearly into timesteps intervals
        # TODO:  Return betas

    
    def add_noise(x_0, t):
        # TODO: Define noise as a random Gaussian noise with similar shape to x_0
        # TODO: Compute x_t by adding noise to x_0 based on q(xt|x0) formula
        # TODO: Return x_t, noise


    def forward(x):
        # TODO: Define variable t by randomly selecting a timestep for each image in batch of images x
        # TODO: Do forward process by adding noise to x, use add_noise function to
        #                                                generate X_noisy and noise
        # TODO: Do reverse process, use reverse_process_model to predict noise 
        #                           of the forward process step's result
        # TODO: Return X_noisy, noise, noise_pred

    @torch.no_grad()
    def sample():
        # TODO: Sample from trained model


def train(diffusion_model, train_loader, optimizer, epochs, device="cuda"):
    for epoch in range(epochs):
        running_loss = 0.0
        for step, (data, target) in enumerate(train_loader):
            x = data.to(device)
            optimizer.zero_grad()
            noise_pred = diffusion_model(x)
            loss = get_loss(noise, noise_pred)
            loss.backward()
            optimizer.step()
            running_loss += loss.item()
            if step % 100 == 0:
                # TODO: Print running loss and plot sample images


def evalualte(diffusion_model, test_loader, device="cuda"):
    # TODO: Evaluate diffusion_model


if __name__ == "__main__":
    device = "cuda"

    # TODO: Define following hyperparameters
    batch_size = 64
    epochs = 100
    learning_rate = 0.001

    # TODO: Define noise schedule parameters
    beta_start = 1e-4
    beta_end = 2e-2

    # Load MNIST dataset
    train_loader, test_loader = load_dataset(batch_size)
    
    # Define model
    reverse_process_model = UNet().to(device)
    diffusion_model = DiffusionModel(reverse_process_model, beta_start, beta_end).to(device)
    
    # Define optimizer
    optimizer = torch.optim.Adam(diffusion_model.parameters(), lr=learning_rate)

    # Train the model
    train(diffusion_model, train_loader, optimizer, epochs, device)

    # Evaluate the model
    evalualte(diffusion_model, test_loader, device)

    # Sample from the model
    diffusion_model.sample()